﻿Imports Zebra.Sdk.Comm
Imports Zebra.Sdk.Printer
Imports Zebra.Sdk.Printer.Discovery

Public Class ZebraPrinter : Implements DiscoveryHandler

    ' Printer Object
    Private my_zPrinterConnection As Connection = Nothing
    Private my_zPrinter As ZebraPrinter = Nothing
    Private my_zebraPrinter As ZebraPrinterLinkOs = Nothing
    Private Shared printers As List(Of DiscoveredPrinter) = New List(Of DiscoveredPrinter)()
    Private BtMacAddress As String = Nothing

    Public ReadOnly Property DiscoveryComplete As Boolean
        Get
            Return myDiscoveryComplete
        End Get
    End Property

    Public Sub GetBluetoothPrinter()
        'Public Shared Sub GetBluetoothPrinter()
        Dim myDiscoveryCompleteStr As String = Nothing
        Try
            Console.WriteLine("Starting printer discovery.")
            'Dim myDiscoveryHandler As ZebraPrinter = New ZebraPrinter()
            'Console.WriteLine("Starting printer discovery: object.")
            ' BluetoothDiscoverer.FindPrinters(myDiscoveryHandler)
            BluetoothDiscoverer.FindPrinters(Me)
        Catch myError As DiscoveryException
            Console.WriteLine(myError.ToString())
        End Try
    End Sub

    'Shared printer As DiscoveredPrinter

    ' This will open/close the printer connection
    Public Sub BTPrinterConnect(ByVal BtMacAddress As String)

        ' Open Close the connection
        If my_zPrinterConnection Is Nothing Then
            ' Open
            Try
                'System.Threading.Thread.Sleep(5000)            
                Console.WriteLine("BtMacAddress = {0}", BtMacAddress)
                my_zPrinterConnection = New BluetoothConnection(BtMacAddress)
                Console.WriteLine("Connecting...")
                my_zPrinterConnection.Open()
                '----- Code Block Commented out by Zebra Technical Support -----------------------------------------------------
                ' Set language       
                'Console.WriteLine("Setting Printer Language...")
                'my_zPrinter = ZebraPrinterFactory.GetInstance(PrinterLanguage.ZPL, my_zPrinterConnection)
                'ZebraPrinterFactory.GetInstance(PrinterLanguage.ZPL, my_zPrinterConnection)
                'Console.WriteLine("Connected...")
                ' Check if worked            
                'If (Not my_zPrinterConnection.Connected) Then
                'Console.WriteLine("Not Connected!")
                'my_zPrinterConnection.Close()
                '    my_zPrinterConnection.Close()
                'my_zPrinter = Nothing
                'End If
                '-----------------------------------------------------------------------------------------------------------------
                Threading.Thread.Sleep(500)
                'get printer information:
                If my_zPrinterConnection.Connected Then
                    Console.WriteLine("Attempting to Get Printer Object & Set Printer Language to ZPL")
                    my_zebraPrinter = ZebraPrinterFactory.GetLinkOsPrinter(my_zPrinterConnection, PrinterLanguage.ZPL)
                    Console.WriteLine("")
                    If (my_zebraPrinter IsNot Nothing) Then
                        Console.WriteLine("Got Printer Object & Set Printer Language to ZPL: Retrieving Printer Status")
                        Dim printerStatus As PrinterStatus = my_zebraPrinter.GetCurrentStatus()
                        Dim status As String = String.Empty
                        If printerStatus.isReadyToPrint Then
                            status = "Ready to Print"
                        Else
                            status = "Not Ready to Print"
                        End If
                        Console.WriteLine("Printer Status is {0}", status)
                    Else
                        Console.WriteLine("Failed to Get Printer Object")
                    End If

                    Console.WriteLine("Closing Connection to Printer")
                Else
                    Console.WriteLine("Failed to Open Connection to Printer")
                End If

            Catch myError As Exception
                'Console.WriteLine("Invalid Mac Address...")
                'Console.WriteLine("Not Connected...")
                Console.WriteLine("Exception thrown: " + myError.Message)
                If Not my_zPrinterConnection Is Nothing Then
                    Try
                        my_zPrinterConnection.Close()

                    Catch
                    End Try
                    Throw myError
                End If
            Finally
                my_zebraPrinter = Nothing
            End Try
        Else
            ' Close            
            my_zPrinterConnection.Close()
            my_zebraPrinter = Nothing
        End If
    End Sub

    Public Sub ConnectToPrinter()
        Try
            If printers.Count > 0 Then
                BTPrinterConnect(printers(0).Address)
            Else
                Console.WriteLine("No Printers Found")
            End If
        Catch ex As Exception

        End Try
    End Sub

    Dim myDiscoveryComplete As Boolean = False
    Dim printer As DiscoveredPrinter
    Public Sub DiscoveryError(ByVal message As String) Implements DiscoveryHandler.DiscoveryError
        Console.WriteLine("An error occurred during discovery: {0}.", message)
        myDiscoveryComplete = True
    End Sub

    Public Sub DiscoveryFinished() Implements DiscoveryHandler.DiscoveryFinished
        Console.WriteLine("Discovery finished...")
        myDiscoveryComplete = True
    End Sub

    Public Sub FoundPrinter(ByVal printer As DiscoveredPrinter) Implements DiscoveryHandler.FoundPrinter

        Console.WriteLine("Found Bluetooth Printer: " + printer.Address)
        printers.Add(printer)

    End Sub



End Class







